﻿Imports System.Globalization
Imports System.Runtime.InteropServices
Imports System.Text
Imports System.Linq
Imports System.Collections.Generic
Imports System

Public Enum JOBCONTROL
    JOB_CONTROL_PAUSE = 1
    JOB_CONTROL_RESUME = 2
    JOB_CONTROL_CANCEL = 3
    JOB_CONTROL_RESTART = 4
    JOB_CONTROL_DELETE = 5
    JOB_CONTROL_SENT_TO_PRINTER = 6
    JOB_CONTROL_LAST_PAGE_EJECTED = 7
    JOB_CONTROL_RETAIN = 8
    JOB_CONTROL_RELEASE = 9
End Enum

<StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Ansi)>
    Public Structure DEVMODE
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=32)>
        Public dmDeviceName As String

        Public dmSpecVersion As Short
        Public dmDriverVersion As Short
        Public dmSize As Short
        Public dmDriverExtra As Short
        Public dmFields As Integer
        Public dmPositionX As Integer
        Public dmPositionY As Integer
        Public dmDisplayOrientation As Integer
        Public dmDisplayFixedOutput As Integer
        Public dmColor As Short
        Public dmDuplex As Short
        Public dmYResolution As Short
        Public dmTTOption As Short
        Public dmCollate As Short

        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=32)>
        Public dmFormName As String

        Public dmLogPixels As Short
        Public dmBitsPerPel As Short
        Public dmPelsWidth As Integer
        Public dmPelsHeight As Integer
        Public dmDisplayFlags As Integer
        Public dmDisplayFrequency As Integer
        Public dmICMMethod As Integer
        Public dmICMIntent As Integer
        Public dmMediaType As Integer
        Public dmDitherType As Integer
        Public dmReserved1 As Integer
        Public dmReserved2 As Integer
        Public dmPanningWidth As Integer
        Public dmPanningHeight As Integer

        Public Overrides Function ToString() As String
            Return String.Format("dmDeviceName == '{0}'," & vbCr & vbLf & "dmSpecVersion == {1}," & vbCr & vbLf & "dmDriverVersion == {2}," & vbCr & vbLf & "dmSize == {3}," & vbCr & vbLf & "dmDriverExtra == {4}," & vbCr & vbLf & "dmFields == {5}," & vbCr & vbLf & "dmPositionX == {6}," & vbCr & vbLf & "dmPositionY == {7}," & vbCr & vbLf & "dmDisplayOrientation == {8}," & vbCr & vbLf & "dmDisplayFixedOutput == {9}," & vbCr & vbLf & "dmColor == {10}," & vbCr & vbLf & "dmDuplex == {11}," & vbCr & vbLf & "dmYResolution == {12}," & vbCr & vbLf & "dmTTOption == {13}," & vbCr & vbLf & "dmCollate == {14}," & vbCr & vbLf & "dmFormName == {15}," & vbCr & vbLf & "dmLogPixels == {16}," & vbCr & vbLf & "dmBitsPerPel == {17}," & vbCr & vbLf & "dmPelsWidth == {18}," & vbCr & vbLf & "dmPelsHeight == {19}," & vbCr & vbLf & "dmDisplayFlags == {20}," & vbCr & vbLf & "dmDisplayFrequency == {21}," & vbCr & vbLf & "dmICMMethod == {22}," & vbCr & vbLf & "dmICMIntent == {23}," & vbCr & vbLf & "dmMediaType == {24}," & vbCr & vbLf & "dmPanningWidth == {25}," & vbCr & vbLf & "dmPanningHeight == {26}", dmDeviceName, dmSpecVersion, dmDriverVersion, dmSize, dmDriverExtra,
                dmFields, dmPositionX, dmPositionY, dmDisplayOrientation, dmDisplayFixedOutput, dmColor,
                dmDuplex, dmYResolution, dmTTOption, dmCollate, dmFormName, dmLogPixels,
                dmBitsPerPel, dmPelsWidth, dmPelsHeight, dmDisplayFlags, dmDisplayFrequency, dmICMMethod,
                dmICMIntent, dmMediaType, dmPanningWidth, dmPanningHeight)

        End Function
    End Structure

    <StructLayout(LayoutKind.Sequential)>
    Public Structure SYSTEMTIME
        <MarshalAs(UnmanagedType.U2)>
        Public Year As Short
        <MarshalAs(UnmanagedType.U2)>
        Public Month As Short
        <MarshalAs(UnmanagedType.U2)>
        Public DayOfWeek As Short
        <MarshalAs(UnmanagedType.U2)>
        Public Day As Short
        <MarshalAs(UnmanagedType.U2)>
        Public Hour As Short
        <MarshalAs(UnmanagedType.U2)>
        Public Minute As Short
        <MarshalAs(UnmanagedType.U2)>
        Public Second As Short
        <MarshalAs(UnmanagedType.U2)>
        Public Milliseconds As Short

        Public Sub New(dt As DateTime)
            dt = dt.ToUniversalTime()
            ' SetSystemTime expects the SYSTEMTIME in UTC
            Year = CType(dt.Year, Short)
            Month = CType(dt.Month, Short)
            DayOfWeek = CType(dt.DayOfWeek, Short)
            Day = CType(dt.Day, Short)
            Hour = CType(dt.Hour, Short)
            Minute = CType(dt.Minute, Short)
            Second = CType(dt.Second, Short)
            Milliseconds = CType(dt.Millisecond, Short)
        End Sub

        Public Function ToDateTime() As DateTime
            Return New DateTime(Year, Month, Day, Hour, Minute, Second,
                Milliseconds, CultureInfo.CurrentCulture.Calendar, DateTimeKind.Utc).ToLocalTime()
        End Function
    End Structure

    <Flags>
    Public Enum JOBSTATUS
        JOB_STATUS_PAUSED = &H1
        JOB_STATUS_ERROR = &H2
        JOB_STATUS_DELETING = &H4
        JOB_STATUS_SPOOLING = &H8
        JOB_STATUS_PRINTING = &H10
        JOB_STATUS_OFFLINE = &H20
        JOB_STATUS_PAPEROUT = &H40
        JOB_STATUS_PRINTED = &H80
        JOB_STATUS_DELETED = &H100
        JOB_STATUS_BLOCKED_DEVQ = &H200
        JOB_STATUS_USER_INTERVENTION = &H400
        JOB_STATUS_RESTART = &H800
        JOB_STATUS_COMPLETE = &H1000
        JOB_STATUS_RETAINED = &H2000
        JOB_STATUS_RENDERING_LOCALLY = &H4000
    End Enum

    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Auto)>
    Public Structure PRINTER_INFO_2
        <MarshalAs(UnmanagedType.LPTStr)>
        Public pServerName As String
        <MarshalAs(UnmanagedType.LPTStr)>
        Public pPrinterName As String
        <MarshalAs(UnmanagedType.LPTStr)>
        Public pShareName As String
        <MarshalAs(UnmanagedType.LPTStr)>
        Public pPortName As String
        <MarshalAs(UnmanagedType.LPTStr)>
        Public pDriverName As String
        <MarshalAs(UnmanagedType.LPTStr)>
        Public pComment As String
        <MarshalAs(UnmanagedType.LPTStr)>
        Public pLocation As String
        Public pDevMode As IntPtr
        <MarshalAs(UnmanagedType.LPTStr)>
        Public pSepFile As String
        <MarshalAs(UnmanagedType.LPTStr)>
        Public pPrintProcessor As String
        <MarshalAs(UnmanagedType.LPTStr)>
        Public pDatatype As String
        <MarshalAs(UnmanagedType.LPTStr)>
        Public pParameters As String
        Public pSecurityDescriptor As IntPtr
        Public Attributes As UInteger
        Public Priority As UInteger
        Public DefaultPriority As UInteger
        Public StartTime As UInteger
        Public UntilTime As UInteger
        Public Status As UInteger
        Public cJobs As UInteger
        Public AveragePPM As UInteger
    End Structure

    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Auto)>
    Public Structure JOB_INFO_1
        Public JobId As UInt32
        Public pPrinterName As String
        Public pMachineName As String
        Public pUserName As String
        Public pDocument As String
        Public pDatatype As String
        Public pStatus As String
        Public Status As UInt32
        Public Priority As UInt32
        Public Position As UInt32
        Public TotalPages As UInt32
        Public PagesPrinted As UInt32
        Public Submitted As SYSTEMTIME
    End Structure

    Public Structure JOBINFO

        Public JobId As Integer

        <MarshalAs(UnmanagedType.LPTStr)>
        Public pPrinterName As String

        <MarshalAs(UnmanagedType.LPTStr)>
        Public pMachineName As String

        <MarshalAs(UnmanagedType.LPTStr)>
        Public pUserName As String

        <MarshalAs(UnmanagedType.LPTStr)>
        Public pDocument As String

        <MarshalAs(UnmanagedType.LPTStr)>
        Public pDatatype As String

        <MarshalAs(UnmanagedType.LPTStr)>
        Public pStatus As String

        Public Status As Integer

        Public Priority As Integer

        Public Position As Integer

        Public TotalPages As Integer

        Public PagesPrinted As Integer

        Public Submitted As SYSTEMTIME

    End Structure


    <Flags>
    Public Enum PRINTERATTRIBUTES
        QUEUED = 1
        DIRECT = 2
        [DEFAULT] = 4
        [SHARED] = 8
        NETWORK = &H10
        HIDDEN = &H20
        LOCAL = &H40
        ENABLE_DEVQ = &H80
        KEEPPRINTEDJOBS = &H100
        DO_COMPLETE_FIRST = &H200
        WORK_OFFLINE = &H400
        ENABLE_BIDI = &H800
        RAW_ONLY = &H1000
        PUBLISHED = &H2000
    End Enum

    <Flags>
    Public Enum PRINTERSTATUS
        PRINTER_STATUS_PAUSED = 1
        PRINTER_STATUS_ERROR = 2
        PRINTER_STATUS_PENDING_DELETION = 4
        PRINTER_STATUS_PAPER_JAM = 8
        PRINTER_STATUS_PAPER_OUT = &H10
        PRINTER_STATUS_MANUAL_FEED = &H20
        PRINTER_STATUS_PAPER_PROBLEM = &H40
        PRINTER_STATUS_OFFLINE = &H80
        PRINTER_STATUS_IO_ACTIVE = &H100
        PRINTER_STATUS_BUSY = &H200
        PRINTER_STATUS_PRINTING = &H400
        PRINTER_STATUS_OUTPUT_BIN_FULL = &H800
        PRINTER_STATUS_NOT_AVAILABLE = &H1000
        PRINTER_STATUS_WAITING = &H2000
        PRINTER_STATUS_PROCESSING = &H4000
        PRINTER_STATUS_INITIALIZING = &H8000
        PRINTER_STATUS_WARMING_UP = &H10000
        PRINTER_STATUS_TONER_LOW = &H20000
        PRINTER_STATUS_NO_TONER = &H40000
        PRINTER_STATUS_PAGE_PUNT = &H80000
        PRINTER_STATUS_USER_INTERVENTION = &H100000
        PRINTER_STATUS_OUT_OF_MEMORY = &H200000
        PRINTER_STATUS_DOOR_OPEN = &H400000
        PRINTER_STATUS_SERVER_UNKNOWN = &H800000
        PRINTER_STATUS_POWER_SAVE = &H1000000
    End Enum

    <FlagsAttribute>
    Public Enum PrinterEnumFlags
        PRINTER_ENUM_DEFAULT = &H1
        PRINTER_ENUM_LOCAL = &H2
        PRINTER_ENUM_CONNECTIONS = &H4
        PRINTER_ENUM_FAVORITE = &H4
        PRINTER_ENUM_NAME = &H8
        PRINTER_ENUM_REMOTE = &H10
        PRINTER_ENUM_SHARED = &H20
        PRINTER_ENUM_NETWORK = &H40
        PRINTER_ENUM_EXPAND = &H4000
        PRINTER_ENUM_CONTAINER = &H8000
        PRINTER_ENUM_ICONMASK = &HFF0000
        PRINTER_ENUM_ICON1 = &H10000
        PRINTER_ENUM_ICON2 = &H20000
        PRINTER_ENUM_ICON3 = &H40000
        PRINTER_ENUM_ICON4 = &H80000
        PRINTER_ENUM_ICON5 = &H100000
        PRINTER_ENUM_ICON6 = &H200000
        PRINTER_ENUM_ICON7 = &H400000
        PRINTER_ENUM_ICON8 = &H800000
        PRINTER_ENUM_HIDE = &H1000000
    End Enum

    Public Class PRINTER_CHANGES
        Public Const PRINTER_CHANGE_ADD_PRINTER As UInteger = 1
        Public Const PRINTER_CHANGE_SET_PRINTER As UInteger = 2
        Public Const PRINTER_CHANGE_DELETE_PRINTER As UInteger = 4
        Public Const PRINTER_CHANGE_FAILED_CONNECTION_PRINTER As UInteger = 8
        Public Const PRINTER_CHANGE_PRINTER As UInteger = &HFF
        Public Const PRINTER_CHANGE_ADD_JOB As UInteger = &H100
        Public Const PRINTER_CHANGE_SET_JOB As UInteger = &H200
        Public Const PRINTER_CHANGE_DELETE_JOB As UInteger = &H400
        Public Const PRINTER_CHANGE_WRITE_JOB As UInteger = &H800
        Public Const PRINTER_CHANGE_JOB As UInteger = &HFF00
        Public Const PRINTER_CHANGE_ADD_FORM As UInteger = &H10000
        Public Const PRINTER_CHANGE_SET_FORM As UInteger = &H20000
        Public Const PRINTER_CHANGE_DELETE_FORM As UInteger = &H40000
        Public Const PRINTER_CHANGE_FORM As UInteger = &H70000
        Public Const PRINTER_CHANGE_ADD_PORT As UInteger = &H100000
        Public Const PRINTER_CHANGE_CONFIGURE_PORT As UInteger = &H200000
        Public Const PRINTER_CHANGE_DELETE_PORT As UInteger = &H400000
        Public Const PRINTER_CHANGE_PORT As UInteger = &H700000
        Public Const PRINTER_CHANGE_ADD_PRINT_PROCESSOR As UInteger = &H1000000
        Public Const PRINTER_CHANGE_DELETE_PRINT_PROCESSOR As UInteger = &H4000000
        Public Const PRINTER_CHANGE_PRINT_PROCESSOR As UInteger = &H7000000
        Public Const PRINTER_CHANGE_ADD_PRINTER_DRIVER As UInteger = &H10000000
        Public Const PRINTER_CHANGE_SET_PRINTER_DRIVER As UInteger = &H20000000
        Public Const PRINTER_CHANGE_DELETE_PRINTER_DRIVER As UInteger = &H40000000
        Public Const PRINTER_CHANGE_PRINTER_DRIVER As UInteger = &H70000000
        Public Const PRINTER_CHANGE_TIMEOUT As UInteger = &H80000000UI
        Public Const PRINTER_CHANGE_ALL As UInteger = &H7777FFFF
    End Class

    Public Enum PRINTERPRINTERNOTIFICATIONTYPES
        PRINTER_NOTIFY_FIELD_SERVER_NAME = 0
        PRINTER_NOTIFY_FIELD_PRINTER_NAME = 1
        PRINTER_NOTIFY_FIELD_SHARE_NAME = 2
        PRINTER_NOTIFY_FIELD_PORT_NAME = 3
        PRINTER_NOTIFY_FIELD_DRIVER_NAME = 4
        PRINTER_NOTIFY_FIELD_COMMENT = 5
        PRINTER_NOTIFY_FIELD_LOCATION = 6
        PRINTER_NOTIFY_FIELD_DEVMODE = 7
        PRINTER_NOTIFY_FIELD_SEPFILE = 8
        PRINTER_NOTIFY_FIELD_PRINT_PROCESSOR = 9
        PRINTER_NOTIFY_FIELD_PARAMETERS = 10
        PRINTER_NOTIFY_FIELD_DATATYPE = 11
        PRINTER_NOTIFY_FIELD_SECURITY_DESCRIPTOR = 12
        PRINTER_NOTIFY_FIELD_ATTRIBUTES = 13
        PRINTER_NOTIFY_FIELD_PRIORITY = 14
        PRINTER_NOTIFY_FIELD_DEFAULT_PRIORITY = 15
        PRINTER_NOTIFY_FIELD_START_TIME = 16
        PRINTER_NOTIFY_FIELD_UNTIL_TIME = 17
        PRINTER_NOTIFY_FIELD_STATUS = 18
        PRINTER_NOTIFY_FIELD_STATUS_STRING = 19
        PRINTER_NOTIFY_FIELD_CJOBS = 20
        PRINTER_NOTIFY_FIELD_AVERAGE_PPM = 21
        PRINTER_NOTIFY_FIELD_TOTAL_PAGES = 22
        PRINTER_NOTIFY_FIELD_PAGES_PRINTED = 23
        PRINTER_NOTIFY_FIELD_TOTAL_BYTES = 24
        PRINTER_NOTIFY_FIELD_BYTES_PRINTED = 25
    End Enum

    Public Enum PRINTERJOBNOTIFICATIONTYPES
        JOB_NOTIFY_FIELD_PRINTER_NAME = 0
        JOB_NOTIFY_FIELD_MACHINE_NAME = 1
        JOB_NOTIFY_FIELD_PORT_NAME = 2
        JOB_NOTIFY_FIELD_USER_NAME = 3
        JOB_NOTIFY_FIELD_NOTIFY_NAME = 4
        JOB_NOTIFY_FIELD_DATATYPE = 5
        JOB_NOTIFY_FIELD_PRINT_PROCESSOR = 6
        JOB_NOTIFY_FIELD_PARAMETERS = 7
        JOB_NOTIFY_FIELD_DRIVER_NAME = 8
        JOB_NOTIFY_FIELD_DEVMODE = 9
        JOB_NOTIFY_FIELD_STATUS = 10
        JOB_NOTIFY_FIELD_STATUS_STRING = 11
        JOB_NOTIFY_FIELD_SECURITY_DESCRIPTOR = 12
        JOB_NOTIFY_FIELD_DOCUMENT = 13
        JOB_NOTIFY_FIELD_PRIORITY = 14
        JOB_NOTIFY_FIELD_POSITION = 15
        JOB_NOTIFY_FIELD_SUBMITTED = 16
        JOB_NOTIFY_FIELD_START_TIME = 17
        JOB_NOTIFY_FIELD_UNTIL_TIME = 18
        JOB_NOTIFY_FIELD_TIME = 19
        JOB_NOTIFY_FIELD_TOTAL_PAGES = 20
        JOB_NOTIFY_FIELD_PAGES_PRINTED = 21
        JOB_NOTIFY_FIELD_TOTAL_BYTES = 22
        JOB_NOTIFY_FIELD_BYTES_PRINTED = 23
    End Enum

    <StructLayout(LayoutKind.Sequential)>
    Public Class PRINTER_NOTIFY_OPTIONS
        Public dwVersion As Integer = 2
        Public dwFlags As Integer
        Public Count As Integer = 2
        Public lpTypes As IntPtr

        Public Sub New()
            Dim bytesNeeded As Integer = (2 + PRINTER_NOTIFY_OPTIONS_TYPE.JOB_FIELDS_COUNT + PRINTER_NOTIFY_OPTIONS_TYPE.PRINTER_FIELDS_COUNT) * 2
            Dim pJobTypes As New PRINTER_NOTIFY_OPTIONS_TYPE()
            lpTypes = Marshal.AllocHGlobal(bytesNeeded)
            Marshal.StructureToPtr(pJobTypes, lpTypes, True)
        End Sub
    End Class

    Public Enum PRINTERNOTIFICATIONTYPES
        PRINTER_NOTIFY_TYPE = 0
        JOB_NOTIFY_TYPE = 1
    End Enum

    <StructLayout(LayoutKind.Sequential)>
    Public Class PRINTER_NOTIFY_OPTIONS_TYPE
        Public Const JOB_FIELDS_COUNT As Integer = 24
        Public Const PRINTER_FIELDS_COUNT As Integer = 23

        Public wJobType As Int16
        Public wJobReserved0 As Int16
        Public dwJobReserved1 As Int32
        Public dwJobReserved2 As Int32
        Public JobFieldCount As Int32
        Public pJobFields As IntPtr
        Public wPrinterType As Int16
        Public wPrinterReserved0 As Int16
        Public dwPrinterReserved1 As Int32
        Public dwPrinterReserved2 As Int32
        Public PrinterFieldCount As Int32
        Public pPrinterFields As IntPtr

        Private Sub SetupFields()
            If pJobFields.ToInt32() <> 0 Then
                Marshal.FreeHGlobal(pJobFields)
            End If

            If wJobType = CType(PRINTERNOTIFICATIONTYPES.JOB_NOTIFY_TYPE, Short) Then
                JobFieldCount = JOB_FIELDS_COUNT
                pJobFields = Marshal.AllocHGlobal((JOB_FIELDS_COUNT * 2) - 1)

                Marshal.WriteInt16(pJobFields, 0, CType(PRINTERJOBNOTIFICATIONTYPES.JOB_NOTIFY_FIELD_PRINTER_NAME, Short))
                Marshal.WriteInt16(pJobFields, 2, CType(PRINTERJOBNOTIFICATIONTYPES.JOB_NOTIFY_FIELD_MACHINE_NAME, Short))
                Marshal.WriteInt16(pJobFields, 4, CType(PRINTERJOBNOTIFICATIONTYPES.JOB_NOTIFY_FIELD_PORT_NAME, Short))
                Marshal.WriteInt16(pJobFields, 6, CType(PRINTERJOBNOTIFICATIONTYPES.JOB_NOTIFY_FIELD_USER_NAME, Short))
                Marshal.WriteInt16(pJobFields, 8, CType(PRINTERJOBNOTIFICATIONTYPES.JOB_NOTIFY_FIELD_NOTIFY_NAME, Short))
                Marshal.WriteInt16(pJobFields, 10, CType(PRINTERJOBNOTIFICATIONTYPES.JOB_NOTIFY_FIELD_DATATYPE, Short))
                Marshal.WriteInt16(pJobFields, 12, CType(PRINTERJOBNOTIFICATIONTYPES.JOB_NOTIFY_FIELD_PRINT_PROCESSOR, Short))
                Marshal.WriteInt16(pJobFields, 14, CType(PRINTERJOBNOTIFICATIONTYPES.JOB_NOTIFY_FIELD_PARAMETERS, Short))
                Marshal.WriteInt16(pJobFields, 16, CType(PRINTERJOBNOTIFICATIONTYPES.JOB_NOTIFY_FIELD_DRIVER_NAME, Short))
                Marshal.WriteInt16(pJobFields, 18, CType(PRINTERJOBNOTIFICATIONTYPES.JOB_NOTIFY_FIELD_DEVMODE, Short))
                Marshal.WriteInt16(pJobFields, 20, CType(PRINTERJOBNOTIFICATIONTYPES.JOB_NOTIFY_FIELD_STATUS, Short))
                Marshal.WriteInt16(pJobFields, 22, CType(PRINTERJOBNOTIFICATIONTYPES.JOB_NOTIFY_FIELD_STATUS_STRING, Short))
                Marshal.WriteInt16(pJobFields, 24, CType(PRINTERJOBNOTIFICATIONTYPES.JOB_NOTIFY_FIELD_SECURITY_DESCRIPTOR, Short))
                Marshal.WriteInt16(pJobFields, 26, CType(PRINTERJOBNOTIFICATIONTYPES.JOB_NOTIFY_FIELD_DOCUMENT, Short))
                Marshal.WriteInt16(pJobFields, 28, CType(PRINTERJOBNOTIFICATIONTYPES.JOB_NOTIFY_FIELD_PRIORITY, Short))
                Marshal.WriteInt16(pJobFields, 30, CType(PRINTERJOBNOTIFICATIONTYPES.JOB_NOTIFY_FIELD_POSITION, Short))
                Marshal.WriteInt16(pJobFields, 32, CType(PRINTERJOBNOTIFICATIONTYPES.JOB_NOTIFY_FIELD_SUBMITTED, Short))
                Marshal.WriteInt16(pJobFields, 34, CType(PRINTERJOBNOTIFICATIONTYPES.JOB_NOTIFY_FIELD_START_TIME, Short))
                Marshal.WriteInt16(pJobFields, 36, CType(PRINTERJOBNOTIFICATIONTYPES.JOB_NOTIFY_FIELD_UNTIL_TIME, Short))
                Marshal.WriteInt16(pJobFields, 38, CType(PRINTERJOBNOTIFICATIONTYPES.JOB_NOTIFY_FIELD_TIME, Short))
                Marshal.WriteInt16(pJobFields, 40, CType(PRINTERJOBNOTIFICATIONTYPES.JOB_NOTIFY_FIELD_TOTAL_PAGES, Short))
                Marshal.WriteInt16(pJobFields, 42, CType(PRINTERJOBNOTIFICATIONTYPES.JOB_NOTIFY_FIELD_PAGES_PRINTED, Short))
                Marshal.WriteInt16(pJobFields, 44, CType(PRINTERJOBNOTIFICATIONTYPES.JOB_NOTIFY_FIELD_TOTAL_BYTES, Short))
                Marshal.WriteInt16(pJobFields, 46, CType(PRINTERJOBNOTIFICATIONTYPES.JOB_NOTIFY_FIELD_BYTES_PRINTED, Short))
            End If

            If pPrinterFields.ToInt32() <> 0 Then
                Marshal.FreeHGlobal(pPrinterFields)
            End If

            If wPrinterType = CType(PRINTERNOTIFICATIONTYPES.PRINTER_NOTIFY_TYPE, Short) Then
                PrinterFieldCount = PRINTER_FIELDS_COUNT
                pPrinterFields = Marshal.AllocHGlobal((PRINTER_FIELDS_COUNT - 1) * 2)

                Marshal.WriteInt16(pPrinterFields, 0, CType(PRINTERPRINTERNOTIFICATIONTYPES.PRINTER_NOTIFY_FIELD_SERVER_NAME, Short))
                Marshal.WriteInt16(pPrinterFields, 2, CType(PRINTERPRINTERNOTIFICATIONTYPES.PRINTER_NOTIFY_FIELD_PRINTER_NAME, Short))
                Marshal.WriteInt16(pPrinterFields, 4, CType(PRINTERPRINTERNOTIFICATIONTYPES.PRINTER_NOTIFY_FIELD_SHARE_NAME, Short))
                Marshal.WriteInt16(pPrinterFields, 6, CType(PRINTERPRINTERNOTIFICATIONTYPES.PRINTER_NOTIFY_FIELD_PORT_NAME, Short))
                Marshal.WriteInt16(pPrinterFields, 8, CType(PRINTERPRINTERNOTIFICATIONTYPES.PRINTER_NOTIFY_FIELD_DRIVER_NAME, Short))
                Marshal.WriteInt16(pPrinterFields, 10, CType(PRINTERPRINTERNOTIFICATIONTYPES.PRINTER_NOTIFY_FIELD_COMMENT, Short))
                Marshal.WriteInt16(pPrinterFields, 12, CType(PRINTERPRINTERNOTIFICATIONTYPES.PRINTER_NOTIFY_FIELD_LOCATION, Short))
                Marshal.WriteInt16(pPrinterFields, 14, CType(PRINTERPRINTERNOTIFICATIONTYPES.PRINTER_NOTIFY_FIELD_SEPFILE, Short))
                Marshal.WriteInt16(pPrinterFields, 16, CType(PRINTERPRINTERNOTIFICATIONTYPES.PRINTER_NOTIFY_FIELD_PRINT_PROCESSOR, Short))
                Marshal.WriteInt16(pPrinterFields, 18, CType(PRINTERPRINTERNOTIFICATIONTYPES.PRINTER_NOTIFY_FIELD_PARAMETERS, Short))
                Marshal.WriteInt16(pPrinterFields, 20, CType(PRINTERPRINTERNOTIFICATIONTYPES.PRINTER_NOTIFY_FIELD_DATATYPE, Short))
                Marshal.WriteInt16(pPrinterFields, 22, CType(PRINTERPRINTERNOTIFICATIONTYPES.PRINTER_NOTIFY_FIELD_ATTRIBUTES, Short))
                Marshal.WriteInt16(pPrinterFields, 24, CType(PRINTERPRINTERNOTIFICATIONTYPES.PRINTER_NOTIFY_FIELD_PRIORITY, Short))
                Marshal.WriteInt16(pPrinterFields, 26, CType(PRINTERPRINTERNOTIFICATIONTYPES.PRINTER_NOTIFY_FIELD_DEFAULT_PRIORITY, Short))
                Marshal.WriteInt16(pPrinterFields, 28, CType(PRINTERPRINTERNOTIFICATIONTYPES.PRINTER_NOTIFY_FIELD_START_TIME, Short))
                Marshal.WriteInt16(pPrinterFields, 30, CType(PRINTERPRINTERNOTIFICATIONTYPES.PRINTER_NOTIFY_FIELD_UNTIL_TIME, Short))
                Marshal.WriteInt16(pPrinterFields, 32, CType(PRINTERPRINTERNOTIFICATIONTYPES.PRINTER_NOTIFY_FIELD_STATUS_STRING, Short))
                Marshal.WriteInt16(pPrinterFields, 34, CType(PRINTERPRINTERNOTIFICATIONTYPES.PRINTER_NOTIFY_FIELD_CJOBS, Short))
                Marshal.WriteInt16(pPrinterFields, 36, CType(PRINTERPRINTERNOTIFICATIONTYPES.PRINTER_NOTIFY_FIELD_AVERAGE_PPM, Short))
                Marshal.WriteInt16(pPrinterFields, 38, CType(PRINTERPRINTERNOTIFICATIONTYPES.PRINTER_NOTIFY_FIELD_TOTAL_PAGES, Short))
                Marshal.WriteInt16(pPrinterFields, 40, CType(PRINTERPRINTERNOTIFICATIONTYPES.PRINTER_NOTIFY_FIELD_PAGES_PRINTED, Short))
                Marshal.WriteInt16(pPrinterFields, 42, CType(PRINTERPRINTERNOTIFICATIONTYPES.PRINTER_NOTIFY_FIELD_TOTAL_BYTES, Short))
                Marshal.WriteInt16(pPrinterFields, 44, CType(PRINTERPRINTERNOTIFICATIONTYPES.PRINTER_NOTIFY_FIELD_BYTES_PRINTED, Short))
            End If
        End Sub

        Public Sub New()
            wJobType = CType(PRINTERNOTIFICATIONTYPES.JOB_NOTIFY_TYPE, Short)
            wPrinterType = CType(PRINTERNOTIFICATIONTYPES.PRINTER_NOTIFY_TYPE, Short)

            SetupFields()
        End Sub
    End Class

    <StructLayout(LayoutKind.Sequential)>
    Public Structure PRINTER_NOTIFY_INFO
        Public Version As UInteger
        Public Flags As UInteger
        Public Count As UInteger
    End Structure


    <StructLayout(LayoutKind.Sequential)>
    Public Structure PRINTER_NOTIFY_INFO_DATA_DATA
        Public cbBuf As UInteger
        Public pBuf As IntPtr
    End Structure

    <StructLayout(LayoutKind.Explicit)>
    Public Structure PRINTER_NOTIFY_INFO_DATA_UNION
        <FieldOffset(0)>
        Private adwData0 As UInteger
        <FieldOffset(4)>
        Private adwData1 As UInteger
        <FieldOffset(0)>
        Public Data As PRINTER_NOTIFY_INFO_DATA_DATA
        Public ReadOnly Property adwData() As UInteger()
            Get
                Return New UInteger() {Me.adwData0, Me.adwData1}
            End Get
        End Property
    End Structure

    ' Structure borrowed from http://lifeandtimesofadeveloper.blogspot.com/2007/10/unmanaged-structures-padding-and-c-part_18.html.
    <StructLayout(LayoutKind.Sequential)>
    Public Structure PRINTER_NOTIFY_INFO_DATA
        Public Type As UShort
        Public Field As UShort
        Public Reserved As UInteger
        Public Id As UInteger
        Public NotifyData As PRINTER_NOTIFY_INFO_DATA_UNION
    End Structure

